
from inspect import signature



class MQTTTrigger:

  def __init__(self, message: str = None, binaryMessage: bytes = None):

    self.__function = None

    if binaryMessage is not None:
      self.__message = binaryMessage
    elif message is not None:
      self.__message = bytes(message, 'UTF-8')
    else:
      self.__message = b''

  # ###################
  # ###  TODO: !!!  ###
  # ###################
  def __call__(self, func=None):
    print(f'__CALL__: self is of type {type(self)} and evaluates to str[ {self} ]')

    if func is not None:

      print(f'storing function[ {signature(func)} ]')
      self.__function = func

      return self.__execute
    else:
      print(f'__call__: executing business logic :)')
      print(f'__call__: self is of type {type(self)} and evaluates to str[ {self} ]')
      if self.__function is not None:
        return self.__function(self)  # TODO: is this the right self we supply?!

  def __execute(self):
    print(f'__execute: executing business logic :)')
    print(f'__execute: self is of type {type(self)} and evaluates to str[ {self} ]')
    if self.__function is not None:
      return self.__function(self)  # TODO: is this the right self we supply?!


class TestDevice:

  @MQTTTrigger(message='restart')
  def restart(self): print(f'self[ {self} ]   RESTART!!!')

  OTA = MQTTTrigger(message='otää otää')


dev = TestDevice()
